Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Class EmptyIterator

    java.lang.Object
      net.sf.saxon.om.EmptyIterator

All Implemented Interfaces:
  LastPositionFinder, ReversibleIterator, AxisIterator, GroundedIterator, LookaheadIterator, SequenceIterator, UnfailingIterator

    public class EmptyIterator

extends Object
implements AxisIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator

EmptyIterator: an iterator over an empty sequence. Since such an iterator has no state, only one instance is required; therefore a singleton instance is available via the static getInstance() method.

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`EmptyIterator()`

Method Summary
`Value` | `atomize()` Return the atomized value of the current node.
`Item` | `current()` Get the current item, that is, the item returned by the most recent call of next().
`SequenceIterator` | `getAnother()` Get another iterator over the same items, positioned at the start.
`static EmptyIterator` | `getInstance()` Get an EmptyIterator, an iterator over an empty sequence.
`int` | `getLastPosition()` Get the position of the last item in the sequence.
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`SequenceIterator` | `getReverseIterator()` Get another iterator over the same items, in reverse order.
`CharSequence` | `getStringValue()` Return the string value of the current node.
`boolean` | `hasNext()` Determine whether there are more items to come.
`AxisIterator` | `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`Value` | `materialize()` Return a Value containing all the items in the sequence returned by this SequenceIterator.
`boolean` | `moveNext()` Move to the next node, without returning it.
`Item` | `next()` Get the next item.
`int` | `position()` Get the position of the current item.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### EmptyIterator

    public EmptyIterator()

Method Detail

### getInstance

    public static EmptyIterator getInstance()

  Get an EmptyIterator, an iterator over an empty sequence.

  Returns:
    an EmptyIterator (in practice, this always returns the same one)

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`

### next

    public Item next()

  Get the next item.

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next item. For the EmptyIterator this is always null.

### current

    public Item current()

  Get the current item, that is, the item returned by the most recent call of next().

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item. For the EmptyIterator this is always null.

### position

    public int position()

  Get the position of the current item.

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    the position of the current item. For the EmptyIterator this is always zero (whether or not the next() method has been called).

### getLastPosition

    public int getLastPosition()

  Get the position of the last item in the sequence.

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`
  Returns:
    the position of the last item in the sequence, always zero in this implementation

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Throws:
    `NullPointerException` - if there is no current node

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `NullPointerException` - if there is no current node
    `XPathException`

### getStringValue

    public CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `NullPointerException` - if there is no current node

### getAnother

    public SequenceIterator getAnother()

  Get another iterator over the same items, positioned at the start.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    another iterator over an empty sequence (in practice, it returns the same iterator each time)

### getReverseIterator

    public SequenceIterator getReverseIterator()

  Get another iterator over the same items, in reverse order.

  Specified by:
    `getReverseIterator` in interface `ReversibleIterator`
  Returns:
    a reverse iterator over an empty sequence (in practice, it returns the same iterator each time)

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### materialize

    public Value materialize()

  Return a Value containing all the items in the sequence returned by this SequenceIterator. This should be an "in-memory" value, not a Closure.

  Specified by:
    `materialize` in interface `GroundedIterator`
  Returns:
    the corresponding Value

### hasNext

    public boolean hasNext()

  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  Specified by:
    `hasNext` in interface `LookaheadIterator`
  Returns:
    true if there are more nodes

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.